
/*********************************************************

PROJECT FILE: main.agc
  by Steve Vink, May 2015
  Use permitted for all purposes, commercial and personal

	This Project is simply to demonstrate the use of the screen shake module
	Do not include this file in your project
	Include only shake.agc

// Project: Screen Shake
// Created: 2015-06-25


**********************************************************/

#include "parameters.agc"
#include "shake.agc"
//#include "debug.agc"

// set window properties
SetWindowTitle( "Screen Shake" )
SetWindowSize( 1920, 1080, 1 )

// set display properties
SetVirtualResolution( 960, 540 )
SetOrientationAllowed( 1, 1, 1, 1 )


//*********************************************************
// Initialise the program
//*********************************************************

	//DebugStart()
	//Load the parameters
	LoadParms("parameters.dat", "main")
	

	// INITIALISE SHAKE
	d# = ValFloat(getParm("duration", "main"))
	c = Val(getParm("count", "main"))
	s# = ValFloat(getParm("scale", "main"))
	initShake(d#,c,s#)
	
	//Create some objects
	createAssets()
	
	while GetPointerReleased() = 0
		
		for n = 1 to arrObj.length
			if GetSpriteFirstContact(arrObj[n]) > 0
				shakeStart()
				null = PlaySound(sndCrash,random(50,100))
				SetSoundInstanceRate(null, (random(60,160) * 0.01))
				exit
			endif
		next n
		
		ShakeUpdate()
		UpdateTweenChain(gShake.chain,GetFrameTime())
		sync()
	endwhile
	



function createAssets()
	
	global sprL
	global sprR
	global sprT
	global sprB
	global sndCrash
	
	vw = GetVirtualWidth() : vh = GetVirtualHeight()
	img = loadimage("pin.png")
	sprL = createSprite(img)
	setSpriteSize(sprL, 10,vh)
	SetSpritePosition(sprL,0,0)
	SetSpritePhysicsOn(sprL,1)
	
	sprR = createSprite(img)
	setSpriteSize(sprR, 10,vh)
	SetSpritePosition(sprR,vw-10,0)
	SetSpritePhysicsOn(sprR,1)
	
	sprT = createSprite(img)
	setSpriteSize(sprT, vw,10)
	SetSpritePosition(sprT,0,0)
	SetSpritePhysicsOn(sprT,1)
	
	sprB = createSprite(img)
	setSpriteSize(sprB, vw,10)
	SetSpritePosition(sprB,0,vh - 10)
	SetSpritePhysicsOn(sprB,1)
	
	for n = 1 to 3
		null = createSprite(img)
		SetSpriteSize(null, 50,50)
		SetSpritePositionByOffset(null, vw / 4 * n, vh / 2)
		SetSpriteAngle(null, 45)
		SetSpritePhysicsOn(null,1)
		SetSpriteColor(null,128,255,128,128)
	next n
	
	//Asteroids
	asteroid = LoadImage("asteroid.png")
	global arrObj as integer[10]
	for n = 1 to 10
		arrObj[n] = createSprite(asteroid)
		setSpriteSize(arrObj[n], 40,40)
		SetSpritePositionByOffset(arrObj[n],(getVirtualWidth() / 11) * n, 50)
		setSpriteColor(arrObj[n], 212 + random(1,50), 212 + random(1,50), 212 + random(1,50),255)
		SetSpritePhysicsOn(arrObj[n],2)
		SetSpritePhysicsFriction(arrObj[n],0)
		SetSpritePhysicsRestitution(arrObj[n],1)
		SetSpriteShapeCircle(arrObj[n],0,0,20)
	next n

	//Load a sound
	sndCrash = LoadSound("crash.wav")

	//Create a background
	img = loadimage("backdrop.jpg")
	bgs = createSprite(img)
	setSpriteSize(bgs, GetVirtualWidth(), GetVirtualHeight())
	SetSpriteDepth(bgs,100)
	SetSpriteColorAlpha(bgs,64)
	EnableClearColor(0)
	
endfunction
